<template>
  <single-panel v-if="rule.titul && rule.titul.status">
    <div class="new-tms">
      <div class="tms-header">
        <div class="tms-header__left">
          <i class="icon chevron-left" @click="goToBrowser"></i>
          <span class="tms-header__number">{{ rule.number }}</span>
          <span class="tms-header__title">
            Политика распределения заказов
          </span>
          <sup :class="rule.titul.status.toLowerCase()">{{ $options.statusMap[rule.titul.status] }}</sup>
        </div>

        <div class="tms-header__right">
          <ob-menu-dropdown
            :items="[
              { title: 'Создать копию политики', icon: 'copy-2', method: () => onCopy() },
              ...(rule.titul.status !== 'STOPPED' ? [{title: 'Удалить политику', className: 'color-error', icon: 'trash', method: () => confirmDelete()}] : []),
              ...(rule.titul.status === 'STOPPED' ?[{title: 'Завершить политику', className: 'color-error', icon: 'delete', method: () => confirmEnd()}] : [])
            ]"
          />
          <i class="icon print"></i>
          <i class="icon save"></i>
          <ob-button v-if="rule.titul.status === 'DRAFT' || rule.titul.status === 'STOPPED'" :disabled="!rule.titul.readyActivate" label="Активировать" @click="changeRuleStatus('ACTIVE')" />
          <ob-button v-if="rule.titul.status === 'ACTIVE'" danger label="Приостановить" @click="onStopRule" />
        </div>
      </div>

      <div class="tms-content">
        <div class="tms-content__left">
          <nav class="tms-content__nav">
            <ob-tabs
              v-model="activeTab"
              :items="tabsItems"
              :no-border="true"
            />
          </nav>

          <div class="tms-content__inner">
            <transition name="fadeIn" mode="out-in">
              <keep-alive>
                <component
                  :style="{ transitionDuration: '0.1s' }"
                  :is="activeComponent"
                  :uuid="$route.params.id"
                />
              </keep-alive>
            </transition>
          </div>
        </div>

        <div class="tms-content__aside">
          <transition name="fadeIn" mode="out-in">
            <keep-alive>
              <component
                :style="{ transitionDuration: '0.1s' }"
                :is="sidebarComponent"
                :rule="rule"
              />
            </keep-alive>
          </transition>
          <ob-button
            v-if="rule.titul.status !== 'ACTIVE' && rule.titul.status !== 'TERMINATED' && rule.titul.status !== 'REMOVED' && this.activeTab.uuid === 'titul'"
            label="Далее"
            :isFullWidth="true"
            :disabled="!(isTitulReady)"
            @click="nextStep"
          />
          <div class="back-button" v-if="this.activeTab.uuid !== 'titul'" @click="stepBack">
            ← Вернуться назад
          </div>
        </div>
      </div>
    </div>

    <ob-modal
      ref="stopRuleModal"
      size="medium"
      title="Приостановить политику?"
      :is-show-controls="true"
      okText="Приостановить"
      isError
      @submit="changeRuleStatus('STOPPED')"
    >
      <div class="stop-rule">
        <div class="stop-rule__row">
          Наименование
          <span>{{ rule.titul.title }}</span>
        </div>
        <div class="stop-rule__row">
          Срок действия политики
          <span>
            {{ new Date(rule.titul.applyFromD).toLocaleDateString('ru-RU') }} - {{ new Date(rule.titul.applyToD).toLocaleDateString('ru-RU') }}
          </span>
        </div>
        <div class="stop-rule__row">
          Квотирование
          <span>{{ $options.typesMap[rule.titul.quotationType] }}</span>
        </div>
        <div class="stop-rule__row">
          Вы сможете позднее в любое время возобновить действие политики.
        </div>
      </div>
    </ob-modal>

    <ob-modal
      ref="removeRuleModal"
      size="medium"
      title="Удалить политику?"
      :is-show-controls="true"
      okText="Удалить"
      cancelText="Не удалять"
      isError
      @submit="changeRuleStatus('REMOVED')"
    >
      <div class="stop-rule">
        <div class="stop-rule__row">
          Вы хотите безвозвратно удалить политику {{ rule.number }}?
        </div>
      </div>
    </ob-modal>

    <ob-modal
      ref="endRuleModal"
      size="medium"
      title="Завершить политику?"
      :is-show-controls="true"
      okText="Завершить"
      cancelText="Отмена"
      isError
      @submit="changeRuleStatus('TERMINATED')"
    >
      <div class="stop-rule">
        <div class="stop-rule__row">
          Наименование
          <span>{{ rule.titul.title }}</span>
        </div>
        <div class="stop-rule__row">
          Срок действия политики
          <span>
            {{ new Date(rule.titul.applyFromD).toLocaleDateString('ru-RU') }} - {{ new Date(rule.titul.applyToD).toLocaleDateString('ru-RU') }}
          </span>
        </div>
        <div class="stop-rule__row">
          Квотирование
          <span>{{ $options.typesMap[rule.titul.quotationType] }}</span>
        </div>
        <div class="stop-rule__row">
          <ob-alert
            text="Все заказы этой политики станут спотовыми(необязательными к исполнению)"
            hideCloseButton
            theme="warning"
            icon="alert"
          />
        </div>
      </div>
    </ob-modal>
  </single-panel>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import api from '@/api';
import SinglePanel from "common-components/src/obComponents/obSinglePanels";
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
import ObButton from 'common-components/src/obComponents/obButton';
import ObTabs from 'common-components/src/obComponents/obTabs';
import ObModal from 'common-components/src/obComponents/obModal';
import ObAlert from 'common-components/src/obComponents/obAlert';
import titulComponent from './components/titul';
import distributionComponent from './components/distribution';
import titulSidebar from './components/titulSidebar';
import distributionSidebar from './components/distributionSidebar';

export default {
  name: 'newTms',

  components: {
    SinglePanel,
    ObMenuDropdown,
    ObButton,
    ObTabs,
    ObModal,
    ObAlert,
    titulComponent,
    distributionComponent,
    titulSidebar,
    distributionSidebar,
  },

  statusMap: {
    DRAFT: 'Черновик',
    ACTIVE: 'Действующая',
    STOPPED: 'Приостановлена',
    TERMINATED: 'Завершена',
    REMOVED: 'Удалена'
  },

  typesMap: {
    'VOLUME_ON_SUBPERIOD': 'Объём на подпериод',
    VOLUME: 'Объём за весь период',
    'VOLUME_SHARE': 'Процент от объёма'
  },

  tabsMap: {
    titul: 'Титул',
    distribution: 'Распределение'
  },
  
  data() {
    return {
      activeTab: { uuid: this.$route.query.tab || 'titul', title: this.$options.tabsMap[this.$route.query.tab] || 'Титул' }
    }
  },

  watch: {
    activeTab (value) {
      this.$router.replace({ query: { ...this.$route.query, tab: value.uuid } })
    }
  },

  computed: {
    ...mapGetters({
      rule: 'tms/rule',
      isTitulSaved: 'tms/isTitulSaved'
    }),

    activeComponent() {
      let componentsMap = {
        "titul": titulComponent,
        'distribution': distributionComponent
      };
      return componentsMap[this.activeTab.uuid]
    },

    sidebarComponent() {
      let componentsMap = {
        "titul": titulSidebar,
        'distribution': distributionSidebar
      };
      return componentsMap[this.activeTab.uuid]
    },

    tabsItems() {
      return [
        {
          uuid: 'titul',
          title: 'Титул'
        },
        {
          uuid: 'distribution',
          title: 'Распределение',
          isDisabled: !this.isTitulSaved
        }
      ]
    },

    isTitulReady() {
      return !!(this.activeTab.uuid === 'titul' && this.rule.titul.title.length && this.rule.titul.quotationType.length && this.rule.titul.applyFromD && this.rule.titul.applyToD);
    },

    isDistDisabled() {
      return !!(this.rule.titul.title.length && this.rule.titul.quotationType.length && this.rule.titul.applyFromD && this.rule.titul.applyToD);
    },

    isTitleValid() {
      return !!this.rule.titul.title.length;
    },

    isTypeValid() {
      return !!this.rule.titul.quotationType.length;
    },

    isDateValid() {
      return this.rule.titul.applyFromD && this.rule.titul.applyToD;
    }
  },

  async created() {
    if (this.$route.params.id === 'new') {
      this.init();
    } else {
      await this.loadData()
    }
  },

  methods: {
    ...mapActions({
      init: 'tms/init',
      setRule: 'tms/setRule',
      setRuleServices: 'tms/setRuleServices',
      setTitulSaved: 'tms/setTitulSaved',
      clearState: 'tms/clearState'
    }),
    async loadData() {
      try {
        const res = await api.tms.getPolicy(this.$route.params.id);
        const services = await api.tms.getPolicyServices(this.$route.params.id, { page: 0, size: 20, sort: "createdAt", direction: "DESC" });
        const payload = {
          uuid: res.uuid,
          number: res.number,
          status: res.status,
          title: res.title,
          quotationType: res.quotationType,
          subperiod: res.subperiod,
          applyFromD: res.applyFromD,
          applyToD: res.applyToD,
          needAutoRenewal: res.needAutoRenewal,
          readyActivate: res.readyActivate
        }
        this.setRule(payload);
        this.setRuleServices(services.content);
        this.setTitulSaved(true);
      } catch (e) {
        console.error(e);
      }
    },
    goToBrowser() {
      this.$router.push('/tms')
      this.clearState();
    },

    stepBack() {
      if (this.activeTab.uuid === 'distribution') {
        this.activeTab = {
          uuid: 'titul',
          title: 'Титул'
        };
      }

      if (this.activeTab.uuid === 'kpi') {
        this.activeTab = {
          uuid: 'distribution',
          title: 'Распределение'
        };
      }
    },

    onCopy() {
      console.log('copy');
    },

    confirmDelete() {
      this.$refs.removeRuleModal.open();
    },

    confirmEnd() {
      this.$refs.endRuleModal.open();
    },

    async nextStep() {
      if (this.activeTab.uuid === 'titul') {
        const uuid = this.rule.uuid;
        const payload = {
          number: this.rule.number,
          title: this.rule.titul.title,
          quotationType: this.rule.titul.quotationType,
          applyFromD: this.rule.titul.applyFromD,
          applyToD: this.rule.titul.applyToD,
          needAutoRenewal: this.rule.titul.needAutoRenewal
        };
        try {
          await api.tms.saveTitul(uuid, payload);
          this.$router.push(`/tms/${uuid}`)
          this.activeTab = {
          uuid: 'distribution',
          title: 'Распределение'
        };
        this.setTitulSaved(true);
        return;
        } catch (e) {
          console.error(e);
        }        
      }

      if (this.activeTab.uuid === 'distribution') {
        this.activeTab = {
          uuid: 'kpi',
          title: 'KPI'
        };
      }
    },

    onStopRule() {
      this.$refs.stopRuleModal.open();
    },

    async changeRuleStatus(status) {
      try {
        await api.tms.changeStatus(this.rule.uuid, status);
        this.$refs.stopRuleModal.close();
        this.$refs.removeRuleModal.close();
        this.$refs.endRuleModal.close();
        if (status === 'STOPPED' || status === 'ACTIVE') {
          await this.loadData();
        }
        if (status === 'REMOVED' || status === 'TERMINATED') {
          this.goToBrowser();
        }
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при совершении операции"
        });
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.left {
  margin-top: 20px;
}

.new-tms {
  flex-grow: 1;
  display: flex;
  flex-direction: column;
}

.tms-header {
  display: flex;
  align-items: center;
  justify-content: space-between;
  height: 76px;
  padding: 0 20px;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
}

.tms-header__left {
  display: flex;
  align-items: center;

  .icon {
    margin-right: 7px;
    font-size: 24px;
    color: $color-blue-navy-blue;
    cursor: pointer;
  }
}

.tms-header__number {
  margin-right: 10px;
  @include font-mixin(24px, 36px, 400, $color-grey-span);
}

.tms-header__title {
  @include font-mixin(24px, 36px, 700, $color-text-base, -0.6px);
}

sup {
  position: relative;
  top: -9px;
  margin-left: 14px;
  @include font-mixin(12px, 20px, 400, $color-error);
}

sup.active {
  color: $deep-blue;
}

.tms-header__right {
  display: flex;
  align-items: center;

  .print, .save {
    font-size: 24px;
  }

  .print {
    margin-left: 11px;
  }

  .save {
    margin-left: 20px;
  }

  button {
    margin-left: 18px;
  }
}

.tms-content {
  flex-grow: 1;
  display: flex;
}

.tms-content__left {
  flex-grow: 1;
}

.tms-content__nav {
  position: relative;
  z-index: 1;
  padding-left: 25px;
  padding-right: 25px;
  @include font-mixin(16px, 20px, 400, $gray-slate, 0.4px);
  box-shadow: 0 2px 8px rgba(0, 75, 200, 0.14);
}

.tms-content__inner {
  padding: 25px;
  height: calc(100% - 40px);
}

.tms-content__aside {
  position: relative;
  z-index: 1;
  width: 316px;
  padding: 30px;
  box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
}

.back-button {
  margin-top: 36px;
  text-align: center;
  @include font-mixin(14px, 18px, 400, $color-blue-navy-blue, 0.4px);
  cursor: pointer;
}

::v-deep {
  .tms-sidebar {
    @include font-mixin(12px, 15px, 400, $color-text-base, 0.4px);
  
    .icon {
      margin-right: 10px;
      color: $color-grey-border;
      font-size: 16px;
    }

    .icon.checked {
      color: $color-green-light;
    }
  }
  
  .tms-sidebar__item {
    margin-bottom: 15px;
    display: flex;
    align-items: center;
  }

  .ob-menu-dropdown-container .menu-dropdown-list__item button .col-left i::before {
    color: $color-blue-smalt;
  }
  
  .ob-menu-dropdown-container .menu-dropdown-list__item.color-error button .col-left i::before {
    color: $color-error;
  }
}

.stop-rule {
  @include font-mixin(16px, 20px, 400, $color-text-base, 0.4px);

  span {
    font-weight: 700;
  }
}

.stop-rule__row {
  display: flex;
  flex-direction: column;
}

.stop-rule__row:not(:first-child) {
  margin-top: 25px;
}

</style>